%define _unpackaged_files_terminate_build 0

%define _java_home		/usr/java
%define _tomcat_home	%{_java_home}/tomcat

#
# Don't make debug package
#
%define debug_package	%{nil}

#
# Don't strip binary
# if follow define list is set, change first character # to %
# (#)(%)define is not permitted, only (#)define (for comment) or (%)define
#
%define __spec_install_post %{nil}
#define __find_requires %{nil}
#define _use_internal_dependency_generator 0
%define __jar_repack %{nil}

Summary: Apache Servlet/JSP Engine, RI for Servlet 2.4/JSP 2.0 API
Name: tomcat
Version: 7.0.68
Release: 1%{?dist}
Epoch: 0
License: Apache Software License
Group: Networking/Daemons
URL: http://tomcat.apache.org/
Source0: http://www.apache.org/dist/tomcat/tomcat-7/v%{version}/bin/apache-tomcat-%{version}.tar.gz
Source1: tomcat.init
Source2: tomcat.sysconfig
Source3: localhost-conf.tar.gz
Source4: tomcat-users.xml
Source5: main-index.tar.gz
Source6: tomcat.logrotate
Source7: tomcat-conf.tar.gz
BuildRoot: /var/tmp/%{name}-%{version}-root
BuildArch: noarch

%description
Tomcat is the servlet container that is used in the official Reference
Implementation for the Java Servlet and JavaServer Pages technologies.
The Java Servlet and JavaServer Pages specifications are developed by
Sun under the Java Community Process.

Tomcat is developed in an open and participatory environment and
released under the Apache Software License. Tomcat is intended to be
a collaboration of the best-of-breed developers from around the world.
We invite you to participate in this open development project.

%prep
%setup -q -n apache-tomcat-%{version}
cd conf
tar xvfpz %{SOURCE3}
cd -
cd webapps/ROOT
tar xvfpz %{SOURCE5}
cd -

%build
%{__chown} -R root:root *
cd conf
tar xvfpz %{SOURCE3}
cd -

%install
[ -d "%{buildroot}" -a "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}
%{__mkdir_p} %{buildroot}%{_tomcat_home}/{bin,work}
%{__mkdir_p} %{buildroot}/var/log/tomcat

find ./bin -name "*.sh" -exec %{__install} -m 755 {} %{buildroot}%{_tomcat_home}/bin/ \;
find ./bin -regex ".*\.\(xml\|jar\|gz\)$" -exec %{__install} -m 644 {} %{buildroot}%{_tomcat_home}/bin/ \;
%{__cp} -af conf %{buildroot}%{_tomcat_home}/
%{__cp} -af lib %{buildroot}%{_tomcat_home}/
%{__cp} -af temp %{buildroot}%{_tomcat_home}/
%{__cp} -af webapps %{buildroot}%{_tomcat_home}/

%{__ln_s} -f /var/log/tomcat %{buildroot}%{_tomcat_home}/logs

%{__mkdir_p} %{buildroot}%{_sysconfdir}/{rc.d/init.d,sysconfig,logrotate.d}
%{__install} -m755 %{SOURCE1} %{buildroot}%{_sysconfdir}/rc.d/init.d/tomcat
%{__install} -m644 %{SOURCE2} %{buildroot}%{_sysconfdir}/sysconfig/tomcat
%{__install} -m600 %{SOURCE4} %{buildroot}%{_tomcat_home}/conf/tomcat-users.xml
%{__install} -m644 %{SOURCE6} %{buildroot}%{_sysconfdir}/logrotate.d/tomcat

pushd %{buildroot}%{_tomcat_home}/conf &> /dev/null
	tar xvfpz %{SOURCE7}
popd &> /dev/null

%clean
[ -d "%{buildroot}" -a "%{buildroot}" != "/" ] && %{__rm} -rf %{buildroot}

%post
# if only install, not update
if [ $1 -eq 1 ]; then
	/sbin/chkconfig --add tomcat
	/sbin/chkconfig --level 35 tomcat on
fi

%preun
if [ $1 -eq 0 ]; then
	/sbin/chkconfig --del tomcat
fi

%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/logrotate.d/tomcat
%dir %{_tomcat_home}/bin
%dir %{_tomcat_home}/lib
%dir %{_tomcat_home}/webapps
%attr(2775,nobody,adm) %dir %{_tomcat_home}/temp
%attr(2775,nobody,adm) %dir %{_tomcat_home}/work
%attr(2775,nobody,adm) %dir /var/log/tomcat
%attr(2775,root,nobody) %dir %{_tomcat_home}/conf
%attr(2775,root,nobody) %dir %{_tomcat_home}/conf/Catalina
%attr(2775,root,nobody) %dir %{_tomcat_home}/conf/Catalina/localhost

%attr(0660,root,nobody) %config(noreplace) %{_tomcat_home}/conf/*.xml
%attr(0660,root,nobody) %config(noreplace) %{_tomcat_home}/conf/*.policy
%attr(0660,root,nobody) %config(noreplace) %{_tomcat_home}/conf/*.properties
%attr(0660,root,nobody) %config(noreplace) %{_tomcat_home}/conf/Catalina/localhost/*.xml
%{_tomcat_home}/bin/*
%{_tomcat_home}/lib/*.jar
%{_tomcat_home}/webapps/*
%exclude %{_tomcat_home}/webapps/examples
%{_tomcat_home}/temp/*
%{_tomcat_home}/logs

%{_sysconfdir}/rc.d/init.d/tomcat
%config(noreplace) %{_sysconfdir}/sysconfig/tomcat

%changelog
* Thu Mar 24 2016 JoungKyun.Kim <http://oops.org> 7.0.68-1%{?dist}
- update 7.0.68

- security issues
  . CVE-2015-5345 Directory disclosure
  . CVE-2015-5351 CSRF token leak
  . CVE-2016-0706 Security Manager bypass
  . CVE-2016-0714 Security Manager bypass
  . CVE-2016-0763 Security Manager bypass

* Thu Feb  4 2016 JoungKyun.Kim <http://oops.org> 7.0.67-1%{?dist}
- update 7.0.67

* Mon Feb  9 2015 JoungKyun.Kim <http://oops.org> 7.0.59-1%{?dist}
- update 7.0.59
- enhanced init for multi instance

* Tue Oct  7 2014 JoungKyun.Kim <http://oops.org> 7.0.55-2%{?dist}
- fixed typo CATRINA_OPT to CATALINA_OPT
- support start options for multi instance with TC_JAVA_OPTS
  on $CATALINA_BASE/conf/options

* Wed Jul 30 2014 JoungKyun.Kim <http://oops.org> 7.0.55-1%{?dist}
- update 7.0.55
  See also http://tomcat.apache.org/tomcat-7.0-doc/changelog.html

- security issuess
  . CVE-2014-0099
  . CVE-2014-0096
  . CVE-2014-0075
  . CVE-2014-0119

* Mon Apr 28 2014 JoungKyun.Kim <http://oops.org> 7.0.53-1%{?dist}
- update 7.0.53
  See also http://tomcat.apache.org/tomcat-7.0-doc/changelog.html

* Fri Mar 21 2014 JoungKyun.Kim <http://oops.org> 7.0.52-1%{?dist}
- update 7.0.52
- security issuess
  . CVE-2014-0050

* Mon Jan 20 2014 JoungKyun.Kim <http://oops.org> 7.0.50-1%{?dist}
- update 7.0.50
- security issues
  . CVE-2013-4322 

* Thu Nov 21 2013 JoungKyun.Kim <http://oops.org> 7.0.47-1%{?dist}
- update 7.0.47
- /etc/sysconfig/tomcat에서 TC_AUTHBIND=yes 설정으로 authbind를 지원
- 설정 파일에서 log rotate하는 것을 rotatelog에서 하도록 변경

* Fri Jul 12 2013 JoungKyun.Kim <http://oops.org> 7.0.42-1%{?dist}
- update 7.0.42
- fixed security issues
  . http://issues.apache.org/bugzilla/show_bug.cgi?id=55119
    Ensure that the build process produces Javadoc that is not vulnerable to
    CVE-2013-1571.

* Sat Jun  1 2013 JoungKyun.Kim <http://oops.org> 7.0.40-1%{?dist}
- update 7.0.40
  See also http://tomcat.apache.org/tomcat-7.0-doc/changelog.html
- fixed security issues
  . CVE-2013-2071 runtime exception in onComplete of AsyncListener

* Tue Mar 12 2013 JoungKyun.Kim <http://oops.org> 7.0.37-1%{?dist}
- 7.0.37 update

* Thu Jan 10 2013 JoungKyun.Kim <http://oops.org> 7.0.34-1%{?dist}
- 7.0.34 update

* Fri Sep  7 2012 JoungKyun.Kim <http://oops.org> 7.0.30-1%{?dist}
- 7.0.30 update

* Fri Apr 13 2012 JoungKyun.Kim <http://oops.org> 7.0.27-2%{?dist}
- support multi instance on init script

* Wed Apr 11 2012 JoungKyun.Kim <http://oops.org> 7.0.27-1%{?dist}
- first packaged
